Bug 67543 - NFS attribute caching bug
Summary: NFS attribute caching bug
Status: CLOSED CURRENTRELEASE
Alias: None
Product: Red Hat Linux
Classification: Retired
Component: kernel (Show other bugs)
(Show other bugs)
Version: 7.3
Hardware: i386 Linux
medium
medium
Target Milestone: ---
Assignee: Steve Dickson
QA Contact: Brian Brock
URL:
Whiteboard:
Keywords:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2002-06-27 04:25 UTC by Yusuf Goolamabbas
Modified: 2007-04-18 16:43 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2004-01-12 12:47:08 UTC
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

Description Yusuf Goolamabbas 2002-06-27 04:25:23 UTC
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.1a+) Gecko/20020625

Description of problem:
The latest redhat kernel release 2.4.18-5 has a lot of NFS patches,
According to NFS client maintainer, Trond Myklebust these seem to
cause excessive GETATTR calls

He has published a patch which fixes this

http://marc.theaimsgroup.com/?l=linux-kernel&m=102503314518420&w=2

Note 100% sure if you need to incorporate this


Version-Release number of selected component (if applicable):


How reproducible:
Always

Steps to Reproduce:
1. upgrade to 2.4.18-5
2. 
3.
	

Additional info:

Comment 1 Jay Hilliard 2003-03-08 08:42:30 UTC
This bug, which appears to continue even in 2.4.18-24.7.x is a showstopper for
us.  Performance in Maya suffers greatly.

Comment 2 Steve Dickson 2003-03-09 19:48:47 UTC
This patch is already in RH9 so I'm not sure 
what (if anything) I should do with this. 

Comment 3 Jay Hilliard 2003-03-11 00:15:04 UTC
RH9?  Will it not be available in a future kernel for 7.3 or 8.0?  Or are you
referring to PHOEBE?

Comment 4 Jay Hilliard 2003-04-18 23:49:57 UTC
excessive GETATTR calls continue in RH7.3, RH8, and even RH9.

What is the likelihood of Tronds patches making it into an errata kernel?

Comment 5 Yusuf Goolamabbas 2003-04-28 14:51:19 UTC
Jay, The latest rawhide kernel changelog mentions some NFS performance patches
being included. Maybe Steve can comment upon those

Comment 6 Bill Heiden 2003-07-12 01:44:43 UTC
 We are also having the same performance problems with maya under both 7.2
(2.4.18-26.7 kernel), 9.0, and the base installation of the v2.1 enterprise WS
kernel.  We've also tried installing Tron's patches with no luck.  However, one
interesting thing is the performance problem only appears with NFS3 in the
enterprise release.  Under a base enterprise installation, setting the nfs
mounts to use NFS2 will result in normal performance.  I've set the mounts to
NFS2 under 2.4.18-26.7 and see the same performance problems.  This is a highly
critical bug for us and is totally impacting our work.

Comment 7 Steve Dickson 2003-07-22 19:58:07 UTC
When you say performance issues what exactly do you mean?
What test suite or commands are you running that
show this poor performance

Comment 8 Jay Hilliard 2003-07-23 00:53:07 UTC
An example of how we can find the problem:

#!/usr/local/bin/perl
### wake up automounter and mount /data/ada14
chdir("/data/ada14/tech");

### stat 3 files 10000 times
undef $done;
$go=0;
while (! $done) {
   @blah = stat("/data/ada14/tech/blah");
   @blah2 = stat("/data/ada14/tech/blah2");
   @blah3 = stat("/data/ada14/tech/blah3");
   $go++;
   if ($go == 10000) {$done = "yes"};
}

print "looped $go times\n";

### NOTE:  automounter mounts /data/ada14 with these options
### -intr --timeout=1800,nfsvers=3,tcp,rsize=32768,wsize=32768
### /data/ada14 is a T3 Array on a Sun V880 with Veritas Filesystem
### Similar results occur when the file server is an SGI Irix 6.5.13 with XLV 
and xfs filesystem.
### If attributes are cached, this test completes almost instantly, if it 
doesn't cache attributes
### of each stat, then it takes a long time to complete.


Comment 9 Bill Heiden 2003-07-23 01:14:21 UTC
 Jay's example perfectly illustrates the problem.  And as another data point, 
this problem exists in the enterprise v2.1 base distro (2.4.9-e.12)with nfs3 
mounts, but not with nfs2 mounts.  However, with an upgrade to 2.4.9-e.25, the 
problem no longer exists for either nfs2 or nfs3.


Note You need to log in before you can comment on or make changes to this bug.